/*
 * error.h - error analysis in lattice context header file
 *
 * HISTORY
 *  created May 2, 1995  Lin Chase (lindaq)
 */


/* how much of this is necessary? */

#define SL 		120		/* words in a sentence 		    */
#define WC		128		/* characters in a word 	    */
#define SC		SL * (WC + 1)	/* characters in a sentence 	    */

#define TL		5000		/* general table length		    */

#define min(x,y)		(((x)<(y)) ? (x) : (y))
#define max(x,y)		(((x)>(y)) ? (x) : (y))
#define pct(x,y)		((y==0) ? (0.0) : (100.0 * (((float) x)/((float) y))))

#define string_to_upper_case(s) { char *_ch; \
				for (_ch=(s); *_ch; _ch++) \
				  if (islower(*_ch)) *_ch = toupper(*_ch); }
#define string_to_lower_case(s) { char *_ch; \
				for (_ch=(s); *_ch; _ch++) \
				  if (isupper(*_ch)) *_ch = tolower(*_ch); }



/* An error region can have hierarchical componentry */

typedef struct err_region_s {
  int err_ID;            /* ?? necessary ?? */
  lat_path_t *ref;       /* the 'correct' answer in lat_path notation */
  lat_path_t *hyp;       /* the hypothesis lat_path being scored/checked */
  int sf;                /* exact first frame where hyp diverges from ref */
  int ef;                /* exact last frame beyond which hyp rejoins ref */
  struct err_region_s *parent; /* parent error region in hierarchy */
  int num_children;      /* how many sub-error-regions this one has */
  struct err_region_s **child;  /* children error regions in hierarchy */
  force_out_reg_t ref_data; /* stores data for ref segments */
  force_out_reg_t hyp_data; /* stores data for hyp segments */
} err_region_t;
















